/*
 * Payload initialisation functions.
 *
 * Copyright (C) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdint.h>

/* Relocate the .data section's contents to initialise mutable structures. */

void relocate_data(uint8_t *original, uint8_t *current, uint32_t size)
{
    uint8_t *limit = original + size;

    /* Copy data from program memory to the relocated data area in RAM. */

    while (original < limit)
        *current++ = *original++;
}
